/**
 * Test for LRU and FIFO page replacement algorithms
 *
 * Usage:
 *	java  Test <reference string size> <number of page frames> <1 or 0>
 */

public class Test
{
	public static void main(String[] args) {
		PageGenerator ref = new PageGenerator(new Integer(args[0]).intValue());
		
		int[] referenceString = {7, 0, 1, 2, 0, 3, 0, 4, 2, 3, 0, 3, 2, 1, 2, 0, 1, 7, 0, 1};
		if ( (new Integer (args[2]).intValue() ) == 0 )
			referenceString = ref.getReferenceString();

		System.out.println("Page reference string:");
		for (int i = 0; i < referenceString.length; i++)
			 System.out.printf("%d, ", referenceString[i]);
		System.out.println("\n");

		
		/** Use either the FIFO or LRU algorithms */
		ReplacementAlgorithm fifo = new FIFO(new Integer(args[1]).intValue());
		ReplacementAlgorithm lru = new LRU(new Integer(args[1]).intValue());

		// output a message when inserting a page
		System.out.println("**********LRU*************");
		for (int i = 0; i < referenceString.length; i++) {
			lru.insert(referenceString[i]);
		}

		// report the total number of page faults
		System.out.println("LRU faults = " + lru.getPageFaultCount());
		System.out.println("============LRU Done============");

		System.out.println();

		// output a message when inserting a page
		System.out.println("**********FIFO*************");
		for (int i = 0; i < referenceString.length; i++) {
			fifo.insert(referenceString[i]);
		}

		// report the total number of page faults
		System.out.println("FIFO faults = " + fifo.getPageFaultCount());
		System.out.println("============FIFO Done============");

	}
}
